// VCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCDemo.h"
#include "VCDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg dialog

CVCDemoDlg::CVCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	TV.left = 60;
	TV.top = 60;
	TV.right = 140;
	TV.bottom = 140;
	
	BUTTON.left = 60;
	BUTTON.top = 60;
	BUTTON.right = 140;
	BUTTON.bottom = 140;
	
	BUTTON.red = 192;
	BUTTON.green = 192;
	BUTTON.blue = 192;

}

void CVCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCDemoDlg)
	DDX_Control(pDX, IDC_BUTTON1, BUTTON);
	DDX_Control(pDX, IDC_KNOB1, KNOB1);
	DDX_Control(pDX, IDC_BLUE, BLUE);
	DDX_Control(pDX, IDC_GREEN, GREEN);
	DDX_Control(pDX, IDC_HEIGHT, HEIGHT);
	DDX_Control(pDX, IDC_KNOB10, KNOB10);
	DDX_Control(pDX, IDC_KNOB11, KNOB11);
	DDX_Control(pDX, IDC_KNOB12, KNOB12);
	DDX_Control(pDX, IDC_KNOB13, KNOB13);
	DDX_Control(pDX, IDC_KNOB14, KNOB14);
	DDX_Control(pDX, IDC_KNOB15, KNOB15);
	DDX_Control(pDX, IDC_KNOB16, KNOB16);
	DDX_Control(pDX, IDC_KNOB17, KNOB17);
	DDX_Control(pDX, IDC_KNOB18, KNOB18);
	DDX_Control(pDX, IDC_KNOB2, KNOB2);
	DDX_Control(pDX, IDC_KNOB3, KNOB3);
	DDX_Control(pDX, IDC_KNOB4, KNOB4);
	DDX_Control(pDX, IDC_KNOB5, KNOB5);
	DDX_Control(pDX, IDC_KNOB6, KNOB6);
	DDX_Control(pDX, IDC_KNOB7, KNOB7);
	DDX_Control(pDX, IDC_KNOB8, KNOB8);
	DDX_Control(pDX, IDC_KNOB9, KNOB9);
	DDX_Control(pDX, IDC_LEFT, LEFT);
	DDX_Control(pDX, IDC_RED, RED);
	DDX_Control(pDX, IDC_TOP, TOP);
	DDX_Control(pDX, IDC_WIDTH, WIDTH);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CVCDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg message handlers

BOOL CVCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CVCDemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVCDemoDlg)
	ON_EVENT(CVCDemoDlg, IDC_BLUE, 1 /* Turn */, OnTurnBlue, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_GREEN, 1 /* Turn */, OnTurnGreen, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_HEIGHT, 1 /* Turn */, OnTurnHeight, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_BLUE, -601 /* DblClick */, OnDblClickBlue, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_GREEN, -601 /* DblClick */, OnDblClickGreen, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_HEIGHT, -601 /* DblClick */, OnDblClickHeight, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB1, -601 /* DblClick */, OnDblClickKnob1, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB10, -601 /* DblClick */, OnDblClickKnob10, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB11, -601 /* DblClick */, OnDblClickKnob11, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB12, -601 /* DblClick */, OnDblClickKnob12, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB13, -601 /* DblClick */, OnDblClickKnob13, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB14, -601 /* DblClick */, OnDblClickKnob14, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB15, -601 /* DblClick */, OnDblClickKnob15, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB16, -601 /* DblClick */, OnDblClickKnob16, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB17, -601 /* DblClick */, OnDblClickKnob17, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB18, -601 /* DblClick */, OnDblClickKnob18, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB2, -601 /* DblClick */, OnDblClickKnob2, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB3, -601 /* DblClick */, OnDblClickKnob3, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB4, -601 /* DblClick */, OnDblClickKnob4, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB5, -601 /* DblClick */, OnDblClickKnob5, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB6, -601 /* DblClick */, OnDblClickKnob6, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB7, -601 /* DblClick */, OnDblClickKnob7, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB8, -601 /* DblClick */, OnDblClickKnob8, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_KNOB9, -601 /* DblClick */, OnDblClickKnob9, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LEFT, 1 /* Turn */, OnTurnLeft, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_RED, 1 /* Turn */, OnTurnRed, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_RED, -601 /* DblClick */, OnDblClickRed, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_TOP, 1 /* Turn */, OnTurnTop, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_TOP, -601 /* DblClick */, OnDblClickTop, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_WIDTH, 1 /* Turn */, OnTurnWidth, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_WIDTH, -601 /* DblClick */, OnDblClickWidth, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_LEFT, -601 /* DblClick */, OnDblClickLeft, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CVCDemoDlg::OnTurnBlue() 
{
	BUTTON.blue = (int) BLUE.GetKnobValue();
	BUTTON.InvalidateRect(NULL,FALSE);
}

void CVCDemoDlg::OnTurnGreen() 
{
	BUTTON.green = (int) GREEN.GetKnobValue();
	BUTTON.InvalidateRect(NULL,FALSE);
}

void CVCDemoDlg::OnTurnHeight() 
{
	BUTTON.bottom = TV.bottom + (int) TOP.GetKnobValue() + (int) HEIGHT.GetKnobValue();
	BUTTON.InvalidateRect(NULL,FALSE);
}

void CVCDemoDlg::OnDblClickBlue() 
{
	BLUE.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickGreen() 
{
	GREEN.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickHeight() 
{
	HEIGHT.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob1() 
{
	KNOB1.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob10() 
{
	KNOB10.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob11() 
{
	KNOB11.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob12() 
{
	KNOB12.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob13() 
{
	KNOB13.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob14() 
{
	KNOB14.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob15() 
{
	KNOB15.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob16() 
{
	KNOB16.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob17() 
{
	KNOB17.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob18() 
{
	KNOB18.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob2() 
{
	KNOB2.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob3() 
{
	KNOB3.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob4() 
{
	KNOB4.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob5() 
{
	KNOB5.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob6() 
{
	KNOB6.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob7() 
{
	KNOB7.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob8() 
{
	KNOB8.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickKnob9() 
{
	KNOB9.ShowPropertyPage();
}

void CVCDemoDlg::OnTurnLeft() 
{
	BUTTON.left = TV.left + (int) LEFT.GetKnobValue();
	BUTTON.right = TV.right + (int) LEFT.GetKnobValue() + (int) WIDTH.GetKnobValue();
	BUTTON.InvalidateRect(NULL,FALSE);
}

void CVCDemoDlg::OnTurnRed() 
{
	BUTTON.red = (int) RED.GetKnobValue();
	BUTTON.InvalidateRect(NULL,FALSE);
}

void CVCDemoDlg::OnDblClickRed() 
{
	RED.ShowPropertyPage();
}

void CVCDemoDlg::OnTurnTop() 
{
	BUTTON.top = TV.top + (int) TOP.GetKnobValue();
	BUTTON.bottom = TV.bottom + (int) TOP.GetKnobValue() + (int) HEIGHT.GetKnobValue();
	BUTTON.InvalidateRect(NULL,FALSE);
}

void CVCDemoDlg::OnDblClickTop() 
{
	TOP.ShowPropertyPage();
}

void CVCDemoDlg::OnTurnWidth() 
{
	BUTTON.right = TV.right + (int) LEFT.GetKnobValue() + (int) WIDTH.GetKnobValue();
	BUTTON.InvalidateRect(NULL,FALSE);
}

void CVCDemoDlg::OnDblClickWidth() 
{
	WIDTH.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickLeft() 
{
	LEFT.ShowPropertyPage();
}

void CTVButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
HBRUSH holdbrush, hbrush;
	
	hbrush = CreateSolidBrush(RGB(192,192,192));
	holdbrush = (HBRUSH) SelectObject(lpDrawItemStruct->hDC,(HGDIOBJ) hbrush);
	
	Rectangle(lpDrawItemStruct->hDC,
		lpDrawItemStruct->rcItem.left,
		lpDrawItemStruct->rcItem.top,
		lpDrawItemStruct->rcItem.right,
		lpDrawItemStruct->rcItem.bottom);
	
	SelectObject(lpDrawItemStruct->hDC,(HGDIOBJ) holdbrush);
	DeleteObject(hbrush);
	
	hbrush = CreateSolidBrush(RGB(red,green,blue));
	SelectObject(lpDrawItemStruct->hDC,(HGDIOBJ) hbrush);
	
	Rectangle(lpDrawItemStruct->hDC,left,top,right,bottom);
	
	/*
		TV.left + (int) LEFT.GetKnobValue(), 
		TV.top + (int) TOP.GetKnobValue(), 
		TV.right + (int) LEFT.GetKnobValue() + (int) WIDTH.GetKnobValue(), 
		TV.bottom + (int) TOP.GetKnobValue() + (int) HEIGHT.GetKnobValue());
	*/
	
	SelectObject(lpDrawItemStruct->hDC,holdbrush);
	DeleteObject(hbrush);
}
