// VCDemoDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg dialog
//{{AFX_INCLUDES()
#include "knob.h"
//}}AFX_INCLUDES

class CTVButton : public CButton
{
public:
	int blue,green,red;
	int left,top,bottom,right;
	
	virtual void DrawItem( LPDRAWITEMSTRUCT lpDrawItemStruct );
};

class CVCDemoDlg : public CDialog
{
// Construction
public:
	CVCDemoDlg(CWnd* pParent = NULL);	// standard constructor
	CRect TV;

// Dialog Data
	//{{AFX_DATA(CVCDemoDlg)
	enum { IDD = IDD_VCDEMO_DIALOG };
	CTVButton	BUTTON;
	CKnob	KNOB1;
	CKnob	BLUE;
	CKnob	GREEN;
	CKnob	HEIGHT;
	CKnob	KNOB10;
	CKnob	KNOB11;
	CKnob	KNOB12;
	CKnob	KNOB13;
	CKnob	KNOB14;
	CKnob	KNOB15;
	CKnob	KNOB16;
	CKnob	KNOB17;
	CKnob	KNOB18;
	CKnob	KNOB2;
	CKnob	KNOB3;
	CKnob	KNOB4;
	CKnob	KNOB5;
	CKnob	KNOB6;
	CKnob	KNOB7;
	CKnob	KNOB8;
	CKnob	KNOB9;
	CKnob	LEFT;
	CKnob	RED;
	CKnob	TOP;
	CKnob	WIDTH;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVCDemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CVCDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTurnBlue();
	afx_msg void OnTurnGreen();
	afx_msg void OnTurnHeight();
	afx_msg void OnDblClickBlue();
	afx_msg void OnDblClickGreen();
	afx_msg void OnDblClickHeight();
	afx_msg void OnDblClickKnob1();
	afx_msg void OnDblClickKnob10();
	afx_msg void OnDblClickKnob11();
	afx_msg void OnDblClickKnob12();
	afx_msg void OnDblClickKnob13();
	afx_msg void OnDblClickKnob14();
	afx_msg void OnDblClickKnob15();
	afx_msg void OnDblClickKnob16();
	afx_msg void OnDblClickKnob17();
	afx_msg void OnDblClickKnob18();
	afx_msg void OnDblClickKnob2();
	afx_msg void OnDblClickKnob3();
	afx_msg void OnDblClickKnob4();
	afx_msg void OnDblClickKnob5();
	afx_msg void OnDblClickKnob6();
	afx_msg void OnDblClickKnob7();
	afx_msg void OnDblClickKnob8();
	afx_msg void OnDblClickKnob9();
	afx_msg void OnTurnLeft();
	afx_msg void OnTurnRed();
	afx_msg void OnDblClickRed();
	afx_msg void OnTurnTop();
	afx_msg void OnDblClickTop();
	afx_msg void OnTurnWidth();
	afx_msg void OnDblClickWidth();
	afx_msg void OnDblClickLeft();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
